// $Id: ajax_slideshow.js,v 1.4 2009/12/07 17:23:14 udig Exp $

/**
 * ajax_slideshow js code. basically it iterates all the nids at the page loading each node using ajax call.
 */
 
var index = 0;
var max = 0;
var nodes = new Array();
var current = 0;
var previous = 0;
var t = new Array();

/**
 * First step : Initialization
 * 1. Make sure at least 1 nid was returned by the view.
 * 2. Attach the placeholders for the nodes display.
 * 3. iterate on the nids and make asynchronous call to the function which returns the nodes.
 * 4. while the asynch calls are on their way call the display function.
 */
Drupal.behaviors.ajax_slideshow = function() {
  max = $('span.field-content').size();
  if (max>0) {
    $('#ajax-slideshow').append('<div id="slideshow-output-wrapper"><div id="node-content0"></div><div id="node-content1"></div></div>');
    $('span.field-content').each( function(i){
      var nid = $('span.field-content').eq(i).text();
      t[i] = setTimeout(function(){loadNode(nid,i)},i*2500); /* Intervaled calles to prevent server load which slows down opening any other link while inside the page*/ 
    });
    displayNodes();

    // Cancel all pending timeouts calls to prevent slowdown when navigating outside of the page
    $("a").click(function () {
      for (i in t) {
        clearTimeout(t[i]);
      }
    });
        
  }
}

/**
 * This function loads a node using ajax protocol.
 * @param {Object} nid - node id.
 * @param {Object} i - index of the loaded node at the array it is stored at.
 */
function loadNode(nid, i) {
  $.get(Drupal.settings.basePath + 'photos/get/photos/' + nid, null, function(data){
    var result = Drupal.parseJson(data);
    nodes[i] = result['node'];
  });  
}


/**
 * This function presents the nodes presumably brought back and saved inside the nodes array.
 * Since we are not sure if the data is already ready (asynch calls) we check that the data exists before presenting it
 */
function displayNodes() {
  mod_index = index%max;
  if (nodes[mod_index]) { /* ensure the node already returned else wait for 2 more second and try again */
  //if ((nodes[max-1]) && (nodes[mod_index])) { /* ensure the last node and this node already returned else wait for 2 more second and try again */
    current = index % 2;
    previous = 1 - current;
    $('#node-content' + current).html(nodes[mod_index]);
    setTimeout("switchNodes()", 2500);
  } else {
    setTimeout("displayNodes()", 2000);
  }
}


function switchNodes(){
  $('#node-content' + previous).fadeOut(2000);
  $('#node-content' + current).fadeIn(2000);

  // after the first slide kicked in we need to hide the intro slide.
  if (index == 0) {
    $('#slideshow-front-content').fadeOut(2000);
  }

  index++;
  setTimeout("displayNodes()", Drupal.settings.ajax_slideshow.slide_duration);
}

/**
* Delay for a number of milliseconds
*/
/*
function sleep(delay)
{
  var start = new Date().getTime();
  while (new Date().getTime() < start + delay);
}
*/

